library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;


entity FSM_TB is

end FSM_TB;



architecture Behavioral of FSM_TB is

    component FSM is
        port(
                clk:        in std_logic; 
                reset:      in std_logic; 
                A:          in std_logic; 
                B:          in std_logic; 
                Led:        out std_logic
                );
    end component;



    --Inputs
    signal clk :        std_logic := '0'; 
    signal A :          std_logic := '0'; 
    signal B :          std_logic := '0'; 
    signal reset :      std_logic := '0';
    
    --Outputs 
    signal Led :        std_logic:= '0';


     -- Clock period definitions
     constant clk_period : time := 8 ns;


begin

-- Instantiate the Unit Under Test (UUT) 
    cut: FSM PORT MAP (
                                        clk => clk,
                                        reset => reset, 
                                        A => A, 
                                        B => B,
                                        Led => Led);

-- Clock process definitions 
    clk_process :process
    begin
        clk <= '0';
        wait for clk_period/2; 
        clk <= '1';
        wait for clk_period/2;
    end process;
    
    
-- Stimulus process
 
    stim_proc: process 
    begin
        -- hold reset state for 100 ns.
        reset <= '0';
        A <= '0';
        B <= '0'; 
        wait for 10*clk_period/2;  --wait for 100 ns;
        reset <= '1';
        A <= '0';
        B <= '0'; 
        wait for 10*clk_period/2; --wait for 1 ms;
        reset <= '0';
        A <= '0';
        B <= '0';        
        wait for 10*clk_period/2; 
        
        
        A <= '0';        
        B <= '1';        
        wait for 10*clk_period;        
        A <= '1';        
        B <= '0';                     
        wait for 10*clk_period;          
        A <= '0';        
        B <= '1';  
        wait for 10*clk_period;
        A <= '1';        
        B <= '0';                
        wait for 10*clk_period;          
        A <= '0';        
        B <= '0';        

        
        wait;
        
    end process;

end Behavioral;

